#include <stdio.h>
#include <stdlib.h>

#include "vfpsearchind.h"
#include "vfpimagehelper.h"

#include "VisioForge_VFP_Types.h"

#ifndef INT64_C
#define INT64_C(c) (c ## LL)
#define UINT64_C(c) (c ## ULL)
#endif

extern "C"
{
#define HAVE_FFMPEG_SWSCALE 1
#include <libavformat/avformat.h>
#include <libavcodec/avcodec.h>
#include <libswscale/swscale.h>
}

#include "ffmpegreader.h"

int vfpsearchind(const char* sourceFile, const char* destFile, int pos, int length)
{

    //	if(argc!=5)
    //        {
    //		printf("\nUsage: index SOURCE DEST POS LENG\n\n");
    //		printf("Index LENG seconds of a SOURCE video, starting from POS, and store signature to the DEST.\n\n");
    //		return 1;
    //	}

    const char* pPathI = sourceFile; // argv[1];
    const char* pPathO = destFile; // argv[2];

    int start = pos; // atoi(argv[3]);
    int count = length; // atoi(argv[4]);

    VFS_TMP* vfp = new VFS_TMP();
    VFPSearch_Init(count, vfp);

    try
    {
        FFMPEGReader ffmpegReader;
        int hr = ffmpegReader.OpenFile(pPathI);

        //CvCapture_FFMPEG* pCapture = cvCreateFileCapture_FFMPEG(, start, count);
        if(hr != 0)
        {
            ffmpegReader.CloseFile();
            return 1;
        }

//        if(!cvGrabFrame_FFMPEG(pCapture))
//        {
//            cvReleaseCapture_FFMPEG(&pCapture);
//            return 1;
//        }

        //unsigned char* pData = NULL;
        int            wStep = 0;
        int            wData = ffmpegReader.GetWidth();
        int            hData = ffmpegReader.GetHeight();
//        int            nChannels = 0;

//        if(!cvRetrieveFrame_FFMPEG(pCapture, &pData, &wStep, &wData, &hData, &nChannels))
//        {
//            cvReleaseCapture_FFMPEG(&pCapture);
//            return 1;
//        }

        double fps = ffmpegReader.GetFrameRate();
        //        cvGetCaptureProperty_FFMPEG(pCapture, CV_FFMPEG_CAP_PROP_FPS);
        if(fps<=0)
        {
            ffmpegReader.CloseFile();
            //cvReleaseCapture_FFMPEG(&pCapture);
            return 1;
        }

        int iFrame = 1;
        //double dTime = 0;
        double dEnd = (double)(start + count);
        int64_t timestamp = 0;

        while(timestamp < dEnd * 1000)
        {
            BYTE* frame = NULL;

            ffmpegReader.GrabFrame(&frame, &wStep, &timestamp);
            if(frame == NULL)
            {
                printf("warning: reached the end before indexing finished\n");
                break;
            }

            //VFPImageHelper helper;
            //helper.SaveImage24(frame, wData, hData, wStep, "/home/roman/Desktop/image.bmp");

            //dTime = (double)timestamp / 1000.0; //((double)iFrame)/fps;
            if(timestamp >= start * 1000)
            {
                VFPSearch_Process(frame, wData, hData, wStep, timestamp, vfp);
                //VFPSearch_Process(frame, wData, hData, wStep, dTime * 1000, vfp);
            }

            iFrame++;
        }

        ffmpegReader.CloseFile();
        //cvReleaseCapture_FFMPEG(&pCapture);

        int n = 0;
        char* p = VFPSearch_Build(&n, vfp);

        if(n)
        {
            FILE* pFile = fopen(pPathO, "w+b");

            int i=0;
            for(i=0; i<n; i += fwrite(p+i, 1, n-i, pFile))
            {

            }
            fclose(pFile);
        }
    }
    catch(...)
    {
        return 0;
    }

    VFPSearch_Clear(vfp);

    return 1;
}



